import os, zlib
from glob import glob

def hexdump(data):
	for i in xrange(0, len(data), 16):
		hc = ''
		ac = ''
		for j in xrange(16):
			if i + j >= len(data):
				hc += '   '
				ac += ' '
			else:
				hc += '%02x ' % (ord(data[i+j]))
				if data[i+j] in 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%^&*()_+-=~`[]{}\\;:\'"|./>?,<':
					ac += data[i+j]
				else:
					ac += '.'
			if j == 7:
				hc += ' '
				ac += ' '
		print '%08x  %s | %s' % (i, hc, ac)
	print

def zipstreams(filename):
	"""Return all zip streams and their positions in file."""
	with open(filename, 'rb') as fh:
		data = fh.read()
	try:
		os.makedirs('dumps/%s' % filename)
	except:
		pass
	i = 0
	last_pos = 0
	bn = 0
	while i < len(data):
		try:
			zo = zlib.decompressobj()
			dc = zo.decompress(data[i:])
			clen = len(data[i:]) - len(zo.unused_data)
			if clen > 1:
				if last_pos != i:
					print 'Uncompressed block @%08x-%08x (%x long)' % (last_pos, i, i-last_pos)
					file('dumps/%s/%i.uncomp' % (filename, bn), 'wb').write(data[last_pos:i])
					bn += 1
					hexdump(data[last_pos:i])
				print 'Compressed block @%08x->%08x (%x compressed, %x decompressed)' % (i, i + clen, clen, len(dc))
				file('dumps/%s/%i.comp' % (filename, bn), 'wb').write(dc)
				bn += 1
				hexdump(dc)
				i += clen
				last_pos = i
			else:
				i += 1
		except zlib.error:
			i += 1
	if i > last_pos:
		print 'Uncompressed block @%08x-%08x (%x long)' % (last_pos, i, i-last_pos)
		file('dumps/%s/%i.uncomp' % (filename, bn), 'wb').write(data[last_pos:i])
		hexdump(data[last_pos:i])

for filename in glob('*.SLDPRT'):
	print 'Solidworks file %s:' % filename
	print
	zipstreams(filename)
	print
